' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/23 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '2lv͈
    Public m_BlobExeRegion As New FvRectangle

    'OCT[`͈
    Public m_GSExeRegion As New FvRectangle

    'xOioj
    Public m_intArrange As Integer

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'ݒpRg[̏
        cmbSearchMode.Items.Add("ʏ̃p^[")   ' NORMAL_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' BLACK_LINE_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' WHITE_LINE_PATTERN"
        cmbSearchMode.Items.Add("sp^[")   ' UNSTABLE_PATTERN"
        cmbSearchMode.SelectedIndex = 0

        cmbPrecision.Items.Add("ʏ퐸x") ' NORMAL_MODE"
        cmbPrecision.Items.Add("x")   ' HIGH_MODE"
        cmbPrecision.Items.Add("x") ' SUPER_MODE"
        cmbPrecision.SelectedIndex = 0

        With cmbColor    'Fݒ
            .Items.Add("BLACK")
            .Items.Add("WHITE")
            .SelectedIndex = 1
        End With

        'o
        rbtArrange0.Checked = True
        m_intArrange = 0

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            frmDisplayEx.Show()

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImageGray.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImageGray.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        'ʂ̐
        frmDisplayEx.AxFvxDisplayEx1.CreateDisplay()
        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImageGray.GetOcx())

        '͈͂̏lݒ(摜̑Sʂɐݒj
        m_GSExeRegion.xs = 0
        m_GSExeRegion.xe = AxFvxImageGray.ImageWidth - 1
        m_GSExeRegion.ys = 0
        m_GSExeRegion.ye = AxFvxImageGray.ImageHeight - 1
        m_BlobExeRegion.xs = 0
        m_BlobExeRegion.xe = AxFvxImageGray.ImageWidth - 1
        m_BlobExeRegion.ys = 0
        m_BlobExeRegion.ye = AxFvxImageGray.ImageHeight - 1
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_GSExeRegion)
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_BlobExeRegion)

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    'J摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImageGray.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImageGray.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImageGray.GetOcx())

    End Sub

    'FvxBlob͈̏͂̐ݒ
    Private Sub btnBlobExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBlobExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_BlobExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImageGray.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_BlobExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_BlobExeRegion.xe < m_BlobExeRegion.xs Then
                dblTemp = m_BlobExeRegion.xs
                m_BlobExeRegion.xs = m_BlobExeRegion.xe
                m_BlobExeRegion.xe = dblTemp
            End If
            If m_BlobExeRegion.ye < m_BlobExeRegion.ys Then
                dblTemp = m_BlobExeRegion.ys
                m_BlobExeRegion.ys = m_BlobExeRegion.ye
                m_BlobExeRegion.ye = dblTemp
            End If
        End If

        DrawExeRegion()

    End Sub

    '2l臒lύX
    Private Sub btnDispBin_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispBin.Click

        Dim intBinLevel As Integer

        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0

        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255

        AxFvxChangeImage1.FixedLevel(AxFvxImageGray.GetOcx(), AxFvxImageBin.GetOcx(), intBinLevel)
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImageBin.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImageGray.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImageGray.BitPerPixel <> 8 Or AxFvxImageGray.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImageGray.BitPerPixel = 8
                AxFvxImageGray.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImageGray.ImageWidth = 512
                AxFvxImageGray.ImageHeight = 480
            End If

            '摜\
            frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImageGray.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImageGray.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    '2lvAp^o^
    Private Sub btnSetPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPattern.Click

        Dim dblTime As Double   '
        Dim intErr As Integer      'G[ԍ
        Dim intCount As Integer    'Blob̌

        Dim intMinSize As Integer  'ŏʐ
        Dim intMaxSize As Integer  'őʐ
        Dim dblAngle As Double  ']p

        Dim intBinLevel As Integer


        'ʏ
        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImageGray.GetOcx())

        '2l
        If Integer.TryParse(txtBinLevel.Text, intBinLevel) = False Then intBinLevel = 0

        If intBinLevel < 0 Then intBinLevel = 0
        If intBinLevel > 255 Then intBinLevel = 255

        AxFvxChangeImage1.FixedLevel(AxFvxImageGray.GetOcx(), AxFvxImageBin.GetOcx(), intBinLevel)

        'ʐϒl`FbN
        If Integer.TryParse(txtMinSize.Text, intMinSize) = False Or intMinSize < 1 Then
            MsgBox("ŏʐϒl͂Pȏ̐lݒ肵Ă", , "p[^G[")
            Exit Sub
        End If
        If Integer.TryParse(txtMaxSize.Text, intMaxSize) = False Or intMinSize >= intMaxSize Then
            MsgBox("ŏʐϒlőʐϒlƂȂ悤ݒ肵Ă", , "p[^G[")
            Exit Sub
        End If

        'őEŏʐϐݒ
        AxFvxBlob1.MinSize = intMinSize
        AxFvxBlob1.MaxSize = intMaxSize

        ']p
        If Double.TryParse(txtAngle.Text, dblAngle) = False Or dblAngle < -180 Or dblAngle > 180 Then
            MsgBox("]p -180.0`180.0 ͈̔͂œ͂Ă", , "p[^G[")
            Exit Sub
        End If
        AxFvxBlob1.angle = dblAngle

        'ΏېFݒ
        If cmbColor.Text = "BLACK" Then
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.BLACK_COLOR
        Else
            AxFvxBlob1.Color = FVXCOMBLOBLib.COLOR_TYPE.WHITE_COLOR
        End If

        'xOiojݒ
        AxFvxBlob1.Arrange = m_intArrange

        '͈͐ڐG
        If chkWndTouch.Checked = True Then
            AxFvxBlob1.WindowTouch = FVXCOMBLOBLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxBlob1.WindowTouch = FVXCOMBLOBLib.WINDOW_TOUCH_TYPE.OFF
        End If

        '͈͐ݒ
        AxFvxBlob1.SetInspectArea(m_BlobExeRegion)

        AxFvxPerformanceCounter1.StartCount()       'ԑJn
        '2lvs
        AxFvxBlob1.Execute(AxFvxImageBin.GetOcx(), intCount)
        AxFvxPerformanceCounter1.StopCount(dblTime)    'ԑI

        'G[oĂ邩mF
        'VBWErrIuWFNgł̓G[ԍ擾ł܂
        'KGetErrReport\bhgăG[ԍ擾Ă
        AxFvxBlob1.GetErrReport(intErr)

        If intErr = 0 Then
            txtResult.Text = VisualBasic.Format(dblTime, "0.00ms")

            'ʕ\tH[
            frmBlobResult.intMaxBlobNo = intCount - 1
            frmBlobResult.Show()

        Else
            MsgBox("G[:" & intErr, vbExclamation, "G[")
        End If

        DrawExeRegion()

    End Sub

    'p^[̃}XNݒ
    Private Sub btnSetPatternMask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPatternMask.Click

        AxFvxPattern1.DefMask()

    End Sub

    'p^[\
    Private Sub btnDispPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPattern.Click

        AxFvxPattern1.Disp()

    End Sub

    'p^[t@C̓Ǎ
    Private Sub btnLoadPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadPattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        OpenFileDialog1.DefaultExt = "*.pat"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.LoadPattrenFileName = OpenFileDialog1.FileName
                AxFvxPattern1.Load()
            Catch ex As Exception
                MsgBox("p^[Ǎݎs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'p^[t@C̕ۑ
    Private Sub btnSavePattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSavePattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        SaveFileDialog1.DefaultExt = "*.pat"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.SavePattrenFileName = SaveFileDialog1.FileName
                AxFvxPattern1.Save()
            Catch ex As Exception
                MsgBox("p^[ۑs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim pSearchResultGroup As New FvSearchResultGroup
        Dim pSearchResult As New FvSearchResult
        Dim pPoint As New FvPoint
        Dim dblTime As Double
        Dim intCount As Integer

        Dim intTemp As Integer
        Dim i As Integer

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImageGray.GetOcx())

        'p[^ݒ
        AxFvxCorrelation1.SetInspectArea(m_GSExeRegion)                   '͈
        AxFvxCorrelation1.SearchMode = cmbSearchMode.SelectedIndex    'T[`[hiׂȂǂ̃p^[Ɏgpj
        AxFvxCorrelation1.Precision = cmbPrecision.SelectedIndex      'T[`

        '摜̏
        If Integer.TryParse(txtCondition.Text, intTemp) = False Or intTemp < 1 Or intTemp > 9 Then
            MsgBox("Ԃ 1`9 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.Condition = intTemp

        '臒l
        If Integer.TryParse(txtThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("XRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.ScoreThresh = intTemp

        'r臒l
        If Integer.TryParse(txtMiddleThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("rXRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.ScoreThresh2 = intTemp

        'T[`
        If Integer.TryParse(txtSearchNum.Text, intTemp) = False Or intTemp < 1 Then
            MsgBox("p[^sł", vbExclamation, "G[")
            Exit Sub
        End If
        AxFvxCorrelation1.SearchNum = intTemp

        '͈͐ڐGĂ̂o邩ǂ
        If chkWndTouch.Checked = True Then
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.OFF
        End If


        Try
            'ԌvJn
            AxFvxPerformanceCounter1.StartCount()

            'p^[ݒ
            AxFvxCorrelation1.SetPattern(AxFvxPattern1.GetOcx())

            'T[`s
            AxFvxCorrelation1.Execute(AxFvxImageGray.GetOcx(), intCount)

            'ԌvI
            AxFvxPerformanceCounter1.StopCount(dblTime)

            '͈͂ŕ\
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_GSExeRegion)

            'T[`ʂԂŕ\
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
            frmDisplayEx.AxFvxDisplayEx1.FontColor = System.Drawing.Color.FromArgb(0, 0, 255)

            txtResult.Text = " : " & VisualBasic.Format(dblTime, "0.00ms") & vbCrLf & vbCrLf & _
                             "T[` : " & VisualBasic.Format(intCount) & vbCrLf & " No      X      Y   score" & vbCrLf

            AxFvxCorrelation1.GetResult(0, pSearchResultGroup)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResultGroup)

            For i = 0 To pSearchResultGroup.Count - 1
                pSearchResult = pSearchResultGroup.Item2(i)
                pPoint.x = pSearchResult.x
                pPoint.y = pSearchResult.y
                frmDisplayEx.AxFvxDisplayEx1.DrawText(0, pPoint, i.ToString())
                txtResult.Text = txtResult.Text & VisualBasic.Format(i, "000  ") & _
                    VisualBasic.Format(pSearchResult.x, "000.0  ") & _
                    VisualBasic.Format(pSearchResult.y, "000.0   ") & _
                    VisualBasic.Format(pSearchResult.score, "000") & vbCrLf
            Next
        Catch ex As Exception
            Dim intErr As Integer
            AxFvxCorrelation1.GetErrReport(intErr)
            MsgBox(GetCorrelationErrMesg(intErr), vbExclamation, "G[")
        End Try

    End Sub

    Private Sub btnGSExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGSExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_GSExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImageGray.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_GSExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_GSExeRegion.xe < m_GSExeRegion.xs Then
                dblTemp = m_GSExeRegion.xs
                m_GSExeRegion.xs = m_GSExeRegion.xe
                m_GSExeRegion.xe = dblTemp
            End If
            If m_GSExeRegion.ye < m_GSExeRegion.ys Then
                dblTemp = m_GSExeRegion.ys
                m_GSExeRegion.ys = m_GSExeRegion.ye
                m_GSExeRegion.ye = dblTemp
            End If

            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_GSExeRegion)
        End If

        DrawExeRegion()

    End Sub

    Private Sub DrawExeRegion()

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_GSExeRegion)
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_BlobExeRegion)

    End Sub

    Public Function GetCorrelationErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetCorrelationErrMesg = "G["
            Case 5001
                GetCorrelationErrMesg = "p^݂Ă܂B"
            Case 5005
                GetCorrelationErrMesg = "p[^Ⴂ܂B"
            Case 5006
                GetCorrelationErrMesg = "^Ⴂ܂B"
            Case 5007
                GetCorrelationErrMesg = "p^摜̂߁Ao^ł܂B"
            Case 5008
                GetCorrelationErrMesg = "p^ƃ}XÑTCYvĂ܂B"
            Case 5009
                GetCorrelationErrMesg = "p[^NULLlw肳܂B"
            Case 5010
                GetCorrelationErrMesg = "̊mۂɎs܂B"
            Case 5022
                GetCorrelationErrMesg = "p^w肳Ă܂B"
            Case Else
                GetCorrelationErrMesg = "sȃG["
        End Select

    End Function

    Private Sub txtBinLevel_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtThreshold.KeyPress, txtSearchNum.KeyPress, txtMinSize.KeyPress, txtMiddleThreshold.KeyPress, txtMaxSize.KeyPress, txtCondition.KeyPress, txtBinLevel.KeyPress, txtAngle.KeyPress

        'l'-'̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Or (e.KeyChar = Chr(&H2D)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub

    Private Sub rbtArrange_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtArrange7.Click, rbtArrange6.Click, rbtArrange5.Click, rbtArrange4.Click, rbtArrange3.Click, rbtArrange2.Click, rbtArrange1.Click, rbtArrange0.Click

        Dim strTemp As String

        strTemp = VisualBasic.Right(sender.name, 1)
        m_intArrange = Integer.Parse(strTemp)

    End Sub
End Class
